<?php 
/**
 * WooCommerce UUID Test Plugin Functions
 *
 * @author   d.stanisheva
 * @package  woo-uuid
 * @since    1.0.0
 */
// CUSTOM TIME INTERVAL
	add_filter('cron_schedules', 'woouuid_cron_add_intervals');
	function woouuid_cron_add_intervals( $schedules ) {
	  $schedules['checkuuid'] = array(
	    'interval' => 300,
	    'display' => __('Every 5min')
	  );
	  return $schedules;
	}

// SETUP CRON
     register_activation_hook(__FILE__, 'woouuid_schedule_cron');

	//add_action('woouuid_cron', 'woouuid_schedule_cron');
	function woouuid_schedule_cron() {
		
	  if ( !wp_next_scheduled( 'woouuid_cron' ) )
	    wp_schedule_event(time(), 'checkuuid', 'woouuid_cron');
	  add_action('woouuid_cron', 'woouuid_cron_function');
	}


// the CRON hook for firing function
	//add_action('woouuid_cron', 'woouuid_cron_function');
       

 	register_deactivation_hook (__FILE__, 'cronstarter_deactivate');
       
    function cronstarter_deactivate() {	
	    $timestamp = wp_next_scheduled ('woouuid_cron');
		$original_args = array();
        wp_unschedule_event ($timestamp, 'woouuid_cron',$original_args);
    } 
   
	function get_processing_orders() {
	  /* global $wpdb;
	   $processing_orders = $wpdb->get_col(
	      $wpdb->prepare(
		 "SELECT posts.ID
		 FROM {$wpdb->prefix}posts AS posts
		 WHERE posts.post_type = 'shop_order'
		 AND posts.post_status = 'wc-on-hold'
	         ")
	   );*/
	   
	   $args = array(
			'status' => 'wc-processing', 
  			'return' => 'ids');
		$query = new WC_Order_Query( $args );
		$processing_orders = $query->get_orders();
	
	    
	   return $processing_orders;
	}
	
	
	
	function woouuid_cron_function() {
	   
	    //wp_mail('dast@abv.bg','Cron Worked', date('r'));
		$orders = get_processing_orders();
		$email_subject = "Completed Orders Email Digest";
        $email_content = "Completed Order IDs: " . implode( "|", $orders );
	       // wp_mail( 'dast@abv.bg', $email_subject, $email_content );
        $warehouseID = get_option( 'warehouseid', true );		
		$domain      = get_option( 'domain', true );
		$onlineStoreID = get_option( 'onlineStoreID', true );

		foreach( $orders as $orderID){

			$order = wc_get_order( $orderID );
            $order_data = $order->get_data(); // The Order data
			
			$hasCR = get_option( 'work_with_cashregister' );
			
			$data = array(
                'orderID' => $orderID,
                'whid'    => $warehouseID	,
				'onlineStoreID' => $onlineStoreID
            );
            
            $url = 'http://'.$domain.'/default/woocommerce/create-woo-order-by-id';

            $response = wp_remote_post( $url , array('body' => $data, 'timeout' => 100 ));
            $responceOperation = json_decode(wp_remote_retrieve_body( $response ), TRUE ); 

            if(isset($responceOperation['data']['error'])){
                //echo "error"; print_r($responceOperation['data']['error']);
                //custom_notification_helper(__('The cash register does not include.', 'woo-uuid' ), 'error');
                
            }
            //custom_notification_helper(__('The order is saved in ICASH.', 'woo-uuid' ), 'success');  		

			
		}
	}



	function woouuid_cron_functionOLD() {
	   
	    //wp_mail('dast@abv.bg','Cron Worked', date('r'));
		$orders = get_processing_orders();
		$email_subject = "Completed Orders Email Digest";
        $email_content = "Completed Order IDs: " . implode( "|", $orders );
	       // wp_mail( 'dast@abv.bg', $email_subject, $email_content );
        

		foreach( $orders as $orderID){

			$order = wc_get_order( $orderID );
		        $order_data = $order->get_data(); // The Order data

			$sendData = new Send_Data_Api_Icash();

		        $contragentID = $sendData->getContragent($order_data ['billing']);
		     
			$onlineSettings = $sendData->getOnlineSettings();
			
			$hasCR = get_option( 'work_with_cashregister' );

			$operationData = $sendData->newOperation($orderID, $contragentID, $onlineSettings['data']['store'], $onlineSettings['data']['chred'] );
		
			if($operationData == false){
				if($hasCR){
				        $text = date('r');
				        $text = $text . "  Cashregister`s online shop does not work";
					//wp_mail('dast@abv.bg','Cron Worked', $text);						
				}
				break;
			}
		        
			$sendData->addOperationSaleItem($order, $operationData['operationID'] );
			$sendData->addShippingMethod($order, $operationData['operationID'], $order_payment_method, $onlineSettings);
			$order_payment_method = $order_data['payment_method'];
 			$hasCR = get_option( 'work_with_cashregister' );
             
			if($hasCR){

				if(isset($operationData['uuid']) && !empty($operationData['uuid'])){				

					$result = $sendData->copmleteOperation($operationData['operationID'], $order_payment_method, $onlineSettings);
			
					//update order :  uuid + status
		
					$order->update_status('printeduuid');	  
					$order->update_meta_data( 'uuid', $operationData['uuid']);
				        $order->save();	

					if($onlineSettings['data']['еlectronicReceipt'] == 'YES' && $result['cr'] == 1) {
						$еlectronicReceipt = $sendData->getOperation($operationData['operationID']); 
   
						if(empty($еlectronicReceipt['OperationElectronicDataQrCode']) ){
							$order->update_status('waitinger', 'order_note'); 
                                                	$order->update_meta_data( 'opID', $operationData['operationID']);	
							$order->save();	
						}else{
							$order->update_meta_data( 'OperationElectronicDataQrCode', $еlectronicReceipt['OperationElectronicDataQrCode']);
							$order->update_meta_data( 'OperationElectronicDataReceipt', $еlectronicReceipt['OperationElectronicDataReceipt']);	
							$order->update_status('printeduuid', 'order_note'); 	
							$order->save();	
							WC()->mailer()->emails['WC_ElectronicData_Order_Email']->trigger($orderID);
						}	
					}
				}
			}else{
				$sendData->copmleteOperation($operationData['operationID'], $order_payment_method, $onlineSettings);
				
				$order->update_status('printeduuid', 'order_note'); 		  
				$order->update_meta_data( 'uuid', $operationData['uuid']);
				$order->save();		
			}
		}
	}


