<?php
/**
 * Plugin Name: Icash tax admin bg
 * Plugin URI: https://v5.icash.bg
 * Author: develop icash
 * Version: 4.3
 * Description: Print cash receipt and get UUID (+ online stores)
 * Text Domain: woo-uuid
 * @package woo-uuid
 */

/**
 * Check if WooCommerce is active
 **/
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ), true ) ) {

	/**
	* Localisation
	*/
	load_plugin_textdomain( 'woo-uuid', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );

	if ( ! class_exists( 'Woo_uuid' ) ) {

	/**
	* Cart Tab class
	*/
		class Woo_uuid{

			/**
			* The token.
			*
			* @var     string
			* @access  public
			* @since   1.1.1
			*/
			public $token;

			/**
			* The version number.
			*
			* @var     string
			* @access  public
			* @since   1.1.1
			*/
			public $version;

			public static $plugin_url;
			public static $plugin_path;
			public static $plugin_basefile;
			public static $plugin_basefile_path;
			public static $plugin_text_domain;
		
			/**
			* Set up all the things
			*/
			public function __construct() {
				$this->token   = 'woo-uuid';
				$this->version = '4.3';
				$this->setup();
				$this->define_constants();
				register_activation_hook( __FILE__, array( $this, 'install' ) );
				add_action( 'init', array( $this, 'localise' ) );
				
				global $wpdb;
			   
    			$results = $wpdb->get_results( "SELECT webhook_id, delivery_url, status FROM {$wpdb->prefix}wc_webhooks" );
				foreach($results as $result)
				{
					if(strpos($result->delivery_url, 'create-order-woocommerce') !== false)
					{
						if(strtolower($result->status) != 'active'){
							
							cronstarter_deactivate();
						} else {
							
							woouuid_schedule_cron();
						}			
					}
				} 

				
			}

			/**
			* Installation.
			* Runs on activation. Logs the version number.
			*
			* @access  public
			* @since   1.1.1
			* @return  void
			*/
			public function install() {
				update_option( $this->token . '-version', $this->version );
			}

			/**
			* Setup
			*
			* @return void
			*/
			public function setup() {
		
				include_once( 'includes/settings-form.php');
				include_once( 'includes/addPrintUUIDStatus.php');
								
				include_once( 'includes/cronCheckPendingOrder.php');
				include_once( 'includes/cronCheckWaitingER.php');
				//include_once( 'includes/sendDataApiIcash.php');
				include_once( 'includes/notifications.php' ); 	
				include_once( 'includes/wcEmail.php' );	
				include_once( 'includes/vendor/phpqrcode.php' );				
			}
			
			/**
			 * Load the localisation 
			 */
			public function localise() {							
				// Load language files from the wp-content/languages/plugins folder
				$mo_file = WP_LANG_DIR . '/plugins/' . self::$plugin_text_domain . '-' . get_locale() . '.mo';

				if( is_readable( $mo_file ) ) {
					load_textdomain( self::$plugin_text_domain, $mo_file );
				}

				// Otherwise load them from the plugin folder
				load_plugin_textdomain( self::$plugin_text_domain, false, dirname( self::$plugin_basefile ) . '/languages/' );
			}

			private function define_constants() {
				self::$plugin_basefile_path = __FILE__;
				self::$plugin_basefile = plugin_basename( self::$plugin_basefile_path );
				self::$plugin_url = plugin_dir_url( self::$plugin_basefile );
				self::$plugin_path = trailingslashit( dirname( self::$plugin_basefile_path ) );	
				self::$plugin_text_domain = trim( dirname( self::$plugin_basefile ) );	
				define( 'CUSTOM_WC_EMAIL_PATH', plugin_dir_path( __FILE__ ) );
				add_option( 'work_with_cashregister', 0);// по подразбиране не се работи с каса			
			}
		}

		$testwoo= new Woo_uuid();
	}	


	/*add_action( 'woocommerce_before_checkout_process', function() {
		
		$warehouseID    = get_option( 'warehouseid', true );		
		$domain         = get_option( 'domain', true );
        $hasCR          = get_option( 'work_with_cashregister' );

		
		global $wpdb;
		$isHookActive = false;
    	$results = $wpdb->get_results( "SELECT webhook_id, delivery_url, status FROM {$wpdb->prefix}wc_webhooks" );
		foreach($results as $result)
		{
			if(strpos($result->delivery_url, 'create-order-woocommerce') !== false)
			{
				if(strtolower($result->status) != 'active'){
					$isHookActive = false;					
				} else {
					$isHookActive = true;
				}			
			}
		} 

		
        if($warehouseID > 0 && $hasCR && $isHookActive) {
			$url = 'http://'.$domain.'/default/Woocommerce/checkcashregister?whid='.$warehouseID;

			$response = wp_remote_get( $url);

			if( is_wp_error( $response ) ) {
                $text = empty($response->errors['http_request_failed'][0]) ? $domain :$response->errors['http_request_failed'][0];
				wc_add_notice(__( 'Error :' .$text, 'woo-uuid' ), 'error' );
				return false; 
			}

			$body = wp_remote_retrieve_body( $response );

			$data = json_decode( $body );
		
			if( ! empty( $data ) ) {

				if($data->response->error == 'OFFLINE'){ 
                                     wc_add_notice(__( 'The cash register does not include.', 'woo-uuid' ), 'error' );
				};
			}   
		}                             

	});*/

 

// Add your custom order status action button (for orders with "processing" status)
	add_filter( 'woocommerce_admin_order_actions', 'add_custom_order_status_print_button', 100, 4 );

	function add_custom_order_status_print_button( $actions, $order ) {
	    // Display the button for all orders that have a 'processing' status

	    if ( $order->has_status( array( 'processing','pending' ) ) ) {

		// Get Order ID (compatibility all WC versions)
		$order_id = method_exists( $order, 'get_id' ) ? $order->get_id() : $order->id;
		// Set the action button
		$actions['print'] = array(
		    'url'       => $order_id,//wp_nonce_url( admin_url( 'admin-ajax.php?action=woocommerce_print_order_admin&status=print&order_id=' . $order_id,'woocommerce-mark-order-status')),  
		//	'url'       => wp_nonce_url( admin_url( 'admin-ajax.php?action=woocommerce_print_order_admin&status=print&order_id=' . $order_id,'woocommerce-mark-order-status')),  
            'name'      => __( 'Print Receipt', 'woo-uuid' ),
		    'action'    => "view print", // keep "view" class for a clean button CSS  
				    
		);
	    }
	    return $actions;
	}

// Set Here the WooCommerce icon for your action button
	add_action( 'admin_head', 'add_custom_order_status_actions_button_css' );

	function add_custom_order_status_actions_button_css() {
		
	    	echo '<style>.view.print::after { font-family: icons; content: "\f163" !important; }</style>';

	}    

    add_action( 'wp_loaded', 'aj_enqueue_scripts' );
	function aj_enqueue_scripts() {
	   

		wp_enqueue_script('jquery'); 
	    	wp_register_script('aj-uuid', plugin_dir_url( __FILE__ ). '/js/aj-uuid-ajax-code.js');

	   
	    	wp_localize_script( 'aj-uuid', 'aj_ajax_uuid', array(
		                'ajax_url' => admin_url( 'admin-ajax.php' ),
		                'aj_demo_nonce' => wp_create_nonce('aj-demo-nonce') 
	    	));

		wp_enqueue_script('aj-uuid');
	}

	add_action ('wp_ajax_woocommerce_print_order_admin', 'woocommerce_print_order_admin') ;
	
	function woocommerce_print_order_admin(){
	
		$orderID     = intval( $_GET['order_id'] );
		$warehouseID = get_option( 'warehouseid', true );		
		$domain      = get_option( 'domain', true );
		$onlineStoreID = get_option( 'onlineStoreID', true );		
 	 
        $data = array(
			'orderID' => $orderID,
			'whid'    => $warehouseID,
			'onlineStoreID' => $onlineStoreID
		);
		$url = 'http://'.$domain.'/default/woocommerce/create-woo-order-by-id';	
		
		//wp_mail('dast@abv.bg','Woo-uuid :', print_r($url, true));	

        $requestData = wp_remote_post( $url , array('body' => $data, 'timeout' => 100 ));
		$responceOperation = json_decode(wp_remote_retrieve_body( $requestData ), TRUE ); 

        //wp_mail('dast@abv.bg','print_order_admin :', print_r($responceOperation, true));	

		if(isset($responceOperation['data']['error'])){
			//echo "error"; print_r($responceOperation['data']['error']);
			custom_notification_helper(__('The cash register does not include.', 'woo-uuid' ), 'error');
			wp_die();
		}
	
 		custom_notification_helper(__('The order is saved in ICASH.', 'woo-uuid' ), 'success');
     		wp_die();

	}
	
	add_filter('plugins_api', 'woouuid_plugin_info', 20, 3);

	function woouuid_plugin_info( $res, $action, $args ){
 
	
		if( 'plugin_information' !== $action ) {
			return false;
		}
 
		$plugin_slug = 'woo-uuid'; // we are going to use it in many places in this function 

		if( $plugin_slug !== $args->slug ) {
			return false;
		}
 
	
		if( false == $remote = get_transient( 'woouuid_update_' . $plugin_slug ) ) {


			$remote = wp_remote_get( 'https://v4.nap.dev.icash.bg/program/WooUUID/woodetails.json', array(
				'timeout' => 10,
				'headers' => array(
					'Accept' => 'application/json'
				) )
			);

			if ( ! is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && ! empty( $remote['body'] ) ) {
				set_transient( 'woouuid_update_' . $plugin_slug, $remote, 43200 ); // 12 hours cache
			}

		}
 
		if( ! is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && ! empty( $remote['body'] ) ) {

			$remote = json_decode( $remote['body'] );
			$res = new stdClass();

			$res->name = $remote->name;
			$res->slug = $plugin_slug;
			$res->version = $remote->version;
			$res->tested = $remote->tested;
			$res->requires = $remote->requires;
			$res->author = '<a href="https://icash.bg">ICASH</a>';
			$res->download_link = $remote->download_url;
			$res->trunk = $remote->download_url;
			$res->requires_php = '5.3';
			$res->last_updated = $remote->last_updated;
			$res->sections = array(
				'description' => $remote->sections->description,
				'installation' => $remote->sections->installation,
				'changelog' => $remote->sections->changelog			
			);

			// in case you want the screenshots tab, use the following HTML format for its content:
			// <ol><li><a href="IMG_URL" target="_blank"><img src="IMG_URL" alt="CAPTION" /></a><p>CAPTION</p></li></ol>
			if( !empty( $remote->sections->screenshots ) ) {
				$res->sections['screenshots'] = $remote->sections->screenshots;
			}

			$res->banners = array(
				'low' => 'https://v4.nap.dev.icash.bg/program/WooUUID/cropped-logo-icash.png',
				'high' => 'https://v4.nap.dev.icash.bg/program/WooUUID/cropped-logo-icash.png'
			);
			//wp_mail('dast@abv.bg','Woo-uuid res:', print_r($res, true));	

			return $res;

		}
 
		return false;
		
 
	}
	
	//add_filter('site_transient_update_plugins', 'woouuid_push_update' );
 
	function woouuid_push_update( $transient ){
 
		if ( empty($transient->checked ) ) {
				return $transient;
			}

		if( false == $remote = get_transient( 'woouuid_upgrade_woo-uuid' ) ) {


			$remote = wp_remote_get( 'https://v4.nap.dev.icash.bg/program/WooUUID/woodetails.json', array(
				'timeout' => 10,
				'headers' => array(
					'Accept' => 'application/json'
				) )
			);

			if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
				set_transient( 'woouuid_upgrade_woo-uuid', $remote, 43200 ); // 12 hours cache
			}

		}
// wp_mail('dast@abv.bg','Woo-uuid res1:', print_r($remote, true));
		if( $remote ) {

			$remote = json_decode( $remote['body'] );

	
			if( $remote && version_compare( '4.3', $remote->version, '<' ) && version_compare($remote->requires, get_bloginfo('version'), '<' ) ) {
				$res = new stdClass();
				$res->slug = 'woo-uuid';
				$res->plugin = 'woo-uuid/woo-uuid.php'; 
				$res->new_version = $remote->version;
				$res->tested = $remote->tested;
				$res->package = $remote->download_url;
					$transient->response[$res->plugin] = $res;
					//$transient->checked[$res->plugin] = $remote->version;
					//wp_mail('dast@abv.bg','Woo-uuid res1:', print_r($res, true));	

				}

		}
		return $transient;
	}
	
	//add_action( 'upgrader_process_complete', 'woouuid_after_update', 10, 2 );
 
	function woouuid_after_update( $upgrader_object, $options ) {
		if ( $options['action'] == 'update' && $options['type'] === 'plugin' )  {
			// just clean the cache when new plugin version is installed
			delete_transient( 'woouuid_upgrade_woo-uuid' );
		}
	}
	
	
add_action('admin_menu', 'test_button_menu');

function test_button_menu(){
  add_menu_page('Test ICASH Page', 'Test ICASH', 'manage_options', 'test-button-slug', 'test_button_admin_page');

}

function test_button_admin_page() {

  // This function creates the output for the admin page.
  // It also checks the value of the $_POST variable to see whether
  // there has been a form submission. 

  // The check_admin_referer is a WordPress function that does some security
  // checking and is recommended good practice.

  // General check for user permissions.
  if (!current_user_can('manage_options'))  {
    wp_die( __('You do not have sufficient pilchards to access this page.')    );
  }

  // Start building the page

  echo '<div class="wrap">';

  echo '<h2>Test ICASH</h2>';

  // Check whether the button has been pressed AND also check the nonce
  if (isset($_POST['test_button']) && check_admin_referer('test_button_clicked')) {
    // the button has been pressed AND we've passed the security check
    test_button_action();
  }

  echo '<form action="options-general.php?page=test-button-slug" method="post">';

  // this is a WordPress security feature - see: https://codex.wordpress.org/WordPress_Nonces
  wp_nonce_field('test_button_clicked');
  echo '<input type="hidden" value="true" name="test_button" />';
  submit_button('Check connection with ICASH');
  echo '</form>';

  echo '</div>';

}

function test_button_action()
{
  echo '<div id="message" class="updated fade"><p>'
    .'The "Check connection with ICASH" button was clicked.' . '</p></div>';
	
	$warehouseID = get_option( 'warehouseid', true );		
	$domain      = get_option( 'domain', true );
		
	$url = 'http://'.$domain.'/default/woocommerce/checkicas?whid='.$warehouseID;
//wp_mail('dast@abv.bg','Woo-uuid test:', print_r($url, true));	
			$response = wp_remote_get( $url, array('timeout'     => 120 ));
	
//wp_mail('dast@abv.bg','Woo-uuid responce:', print_r($response, true));	
			if( is_wp_error( $response ) ) {
                $text = empty($response->errors['http_request_failed'][0]) ? $domain :$response->errors['http_request_failed'][0];
				wc_add_notice(__( 'Error :' .$text, 'woo-uuid' ), 'error' );
				echo '<p>Error: </p>';
				return false; 
			}

			$body = wp_remote_retrieve_body( $response );

			$data = json_decode( $body );
		//wp_mail('dast@abv.bg','Woo-uuid data:', print_r($data, true));	
			
			if( ! empty( $data ) ) {
				if($data->response == true){                 
 				 echo '<p>OK: Has connection </p>';
				  echo '<div id="message" class="updated fade"><p>'
    				.'OK: Has connection with ICASH.' . '</p></div>';
				}
			} else {
				 echo '<div id="message" class="error"><p>'
    				.'Error: Has not connection with ICASH.' . '</p></div>';
			}  

}  

}
